program sol;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes;

const MaxN=10;

var f:text;
var tmp,a:array[1..MaxN] of integer;
var gcd:array[1..MaxN,1..MaxN] of integer;
var t,n,i,j:integer;
var ans:int64;

function Euclidus(a,b:integer):integer;
var r:integer;
begin
  while (b<>0) do begin
    r:=a mod b;
    a:=b;
    b:=r;
  end;
  result:=a;
end;

procedure Calculate;
var i:integer;
var sum:int64;
begin
  i:=1;
  sum:=0;
  while (i<n) do begin
    sum:=sum+gcd[ tmp[i] , tmp[i+1]];
    i:=i+2;
  end;
  if (sum>ans) then begin
    ans:=sum;
  end;
end;

procedure Permutate(d:integer);
var t,i:integer;
begin
  if (d=n) then begin
    Calculate;
    exit;
  end;
  for i:=d+1 to n do begin
      Permutate(d+1);
      t:=tmp[d]; tmp[d]:=tmp[i]; tmp[i]:=t;
  end;
  Permutate(d+1);
  t:=tmp[d];
  for i:=d to n-1 do
      tmp[i]:=tmp[i+1];
  tmp[n]:=t;
end;

begin
  assignfile(f,'input.txt');
  reset(f);
  read(f,n); n:=2*n;
  for i:=1 to n do
      read(f,a[i]);
  closefile(f);
  for i:=1 to n do
      for j:=1 to n do
          if (i<>j) then begin
            t:=Euclidus(a[i],a[j]);
            gcd[i,j]:=t;
            gcd[j,i]:=t;
          end;
  for i:=1 to n do
      tmp[i]:=i;
  ans:=0;
  Permutate(1);
  assignfile(f,'output.txt');
  rewrite(f);
  writeln(f,ans);
  closefile(f);
end.

