#include <algorithm>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <vector>

using namespace std;

const int maxn = 20;

int n;
int a[maxn];
int d[1 << maxn];
int g[maxn][maxn];

int gcd(int a, int b)
{
    while (a) {
        int r = a;
        a = b % a;
        b = r;
    }
    return b;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int i, j;

    cin >> n;
    n *= 2;
    for (i = 0; i < n; i++)
        cin >> a[i];

    for (i = 0; i < n; i++)
        for (j = 0; j < n; j++)
            g[i][j] = gcd(a[i], a[j]);

    for (int m = 0; m < (1 << n); m++) {
        int num1 = 0;
        int m1 = m;
        while (m1) {
            m1 &= m1 - 1;
            num1++;
        }
        if (num1 % 2 == 1) continue;

        for (i = 0; i < n; i++)
            for (j = 0; j < n; j++)
                if (i != j && !(m & (1 << i)) && !(m & (1 << j))) {
                    int p = d[m] + g[i][j];
                    int q = m + (1 << i) + (1 << j);
                    if (p > d[q]) d[q] = p;
                }
    }

    cout << d[(1 << n) - 1] << endl;

    fclose(stdin);
    fclose(stdout);
    return 0;
}
