{$MAXSTACKSIZE 128000000}

program sol3;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes
  { you can add units after this };

const MaxN=10;

type TPair = record
  a,b,g:integer;
end;

var f:text;
var t,j,z,i,n:integer;
var a:Array[1..2*MaxN] of integer;
var p:array[1..MaxN*MaxN] of TPair;
var gcd:array[1..2*MaxN, 1..2*MaxN] of integer;
var vis:array[1..2*MaxN] of boolean;
var tmp:array[1..MaxN] of integer;
var ans:int64;

function Euclidus(a,b:integer):integer;
var r:integer;
begin
  while (b<>0) do begin
    r:=a mod b;
    a:=b;
    b:=r;
  end;
  result:=a;
end;

procedure Calc;
var sum:int64;
begin
  sum:=0;
  for i:=1 to (n div 2) do begin
      sum:=sum+p[tmp[i]].g;
  end;
  if sum>ans then ans:=sum;

end;

procedure TryPair(d:integer);
var cx,i:integer;
begin
  if (d>(n div 2)) then begin
    Calc;
    exit;
  end;
  cx:=0;
  for i:=1 to z do begin
      if (not vis[p[i].a]) and (not vis[p[i].b]) then begin
        inc(cx);
        tmp[d]:=i;
        vis[p[i].a]:=true;
        vis[p[i].b]:=true;
        TryPair(d+1);
        vis[p[i].a]:=false;
        vis[p[i].b]:=false;
      end;
      if (cx>2) then exit;
  end;

end;

procedure GenerateAllPairs();
var i,j:integer;
var t:TPair;
begin
  for i:=1 to n do
      for j:=i+1 to n do begin
          inc(z);
          p[z].a:=i;
          p[z].b:=j;
          p[z].g:=gcd[i,j];
      end;

  for i:=1 to z do
      for j:=1 to z-1 do
          if (p[j].g<p[j+1].g) then begin
            t:=p[j];
            p[j]:=p[j+1];
            p[j+1]:=t;
          end;

  for i:=1 to z do writeln(p[i].a, ' ', p[i].b);

end;

begin
  z:=0;
  assignfile(f,'input.txt');
  reset(f);
  read(f,n); n:=2*n;
  for i:=1 to n do
      read(f,a[i]);
  closefile(f);

  for i:=1 to n do
      for j:=1 to n do
          if (i<>j) then begin
            t:=Euclidus(a[i],a[j]);
            gcd[i,j]:=t;
            gcd[j,i]:=t;
          end;
  GenerateAllPairs;
  fillchar(vis,sizeof(vis),false);
  TryPair(1);

  assignfile(f,'output.txt');
  rewrite(f);
  write(f,ans);
  closefile(f);

end.

